<script lang="ts">
import Vue from 'vue';
import type { PropType } from 'vue';

interface Bullet {
  title: string;
  description: string;
  accordion: {
    text: string;
    open: boolean;
    button: {
      text: string;
      url: string;
    };
  };
}

interface Category {
  title: string;
  verb: string;
  bullets: Bullet[];
  customer: {
    logo: string;
    text: string;
    href: string;
    button: {
      text: string;
      href: string;
      dataGaName?: string;
    };
  };
  cta: {
    icon: string;
    title: string;
    text: string;
    button: {
      text: string;
      href: string;
      dataGaName?: string;
    };
  };
}

export default Vue.extend({
  props: {
    categories: {
      type: Array as PropType<Category[]>,
      required: true,
    },
    header: {
      type: String,
      required: true,
    },
    organization: {
      type: String,
      required: true,
    },
    footer: {
      type: Array as PropType<string[]>,
      required: true,
    },
  },
  data() {
    return {
      selectedCategory: 1,
      selectorOpen: false,
    };
  },
  computed: {
    category() {
      return this.categories[this.selectedCategory] as Category;
    },
    footerLinks() {
      const links = this.categories.map(
        (category: Category, index: number) => ({
          index,
          title: category.title,
        }),
      );
      links.splice(this.selectedCategory, 1);
      return links;
    },
  },
  methods: {
    setSelectedCategory(value: number) {
      this.selectedCategory = value;
    },
    openSelector() {
      this.selectorOpen = true;
    },
    selectorChange(event: Event, value: number) {
      if (this.selectorOpen) {
        event.stopPropagation();
        this.setSelectedCategory(value);
        this.selectorOpen = false;
      } else {
        this.openSelector();
      }
    },
    toggleBullet(bullet: Bullet) {
      if (bullet.accordion) {
        bullet.accordion.open = !bullet.accordion.open;
      }
    },
  },
});
</script>

<template>
  <SlpContainer>
    <div id="why-gitlab-categories">
      <div class="selector-block">
        <SlpTypography variant="heading4-bold" class="hide-in-mobile">{{
          header
        }}</SlpTypography>
        <div
          class="selector"
          :class="{ open: selectorOpen }"
          @click="openSelector"
        >
          <div class="option-container" :class="`step-${selectedCategory}`">
            <div
              v-for="(option, index) in categories"
              :key="option.title"
              class="option"
              :class="{ selected: index === selectedCategory }"
              @click="($event) => selectorChange($event, index)"
            >
              <SlpTypography variant="heading4-bold" class="label"
                >{{ option.title }}
                <SlpIcon
                  name="chevron-down"
                  variant="product"
                  size="md"
                  class="chevron"
                  :class="{
                    open: selectorOpen,
                  }"
              /></SlpTypography>
            </div>
          </div>
        </div>

        <SlpTypography variant="heading4-bold" class="hide-in-mobile"
          >{{ category.verb }} {{ organization }}
        </SlpTypography>
      </div>
      <transition name="fade" mode="out-in" tag="div">
        <div
          :key="category.title"
          class="category"
          :data-ga-section="category.title"
        >
          <div class="information">
            <div class="bullets">
              <div
                v-for="(bullet, index) in category.bullets"
                :key="bullet.title"
                class="bullet-accordion"
                :class="{ 'has-content': bullet.accordion }"
                @click="toggleBullet(bullet)"
              >
                <div class="bullet">
                  <SlpTypography variant="heading4-bold">
                    <span class="counter">{{ index + 1 }}</span>
                  </SlpTypography>
                  <div class="bullet-text">
                    <SlpTypography variant="heading4-bold">
                      {{ bullet.title }}</SlpTypography
                    >
                    <SlpTypography variant="body1" class="description">{{
                      bullet.description
                    }}</SlpTypography>
                    <div v-if="bullet.accordion" class="expand">
                      <div class="details">
                        <SlpTypography>{{ $t('learnMore') }}</SlpTypography>
                        <SlpIcon
                          v-if="bullet.accordion.open"
                          class="faq__expand-icon"
                          name="dash"
                          variant="product"
                          aria-label="Less details button"
                          alt="Dash Icon"
                          size="sm"
                        />
                        <SlpIcon
                          v-else
                          class="faq__expand-icon"
                          name="plus"
                          aria-label="More details button"
                          variant="product"
                          alt="Plus Icon"
                          size="sm"
                        />
                      </div>
                      <div
                        v-if="bullet.accordion && bullet.accordion.open"
                        class="accordion"
                      >
                        <div
                          class="content"
                          @click.stop
                          v-html="$md.render(bullet.accordion.text)"
                        ></div>
                        <SlpButton
                          v-if="bullet.accordion.button"
                          class="slp-mt-24"
                          :href="bullet.accordion.button.url"
                        >
                          {{ bullet.accordion.button.text }}</SlpButton
                        >
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>
            <div class="customer-case">
              <div class="case-wrapper">
                <img :src="category.customer.logo" alt="" class="logo" />
                <SlpTypography variant="heading5-bold">{{
                  category.customer.text
                }}</SlpTypography>
                <SlpButton
                  :href="category.customer.button.href"
                  variant="tertiary"
                  :data-ga-name="category.customer.button.dataGaName"
                  :data-ga-location="category.title"
                >
                  {{ category.customer.button.text
                  }}<SlpIcon name="chevron-right" variant="product"
                /></SlpButton>
              </div>
            </div>
          </div>
          <div class="cta">
            <SlpIcon :name="category.cta.icon" variant="marketing" size="md" />
            <SlpTypography variant="heading4-bold">{{
              category.cta.title
            }}</SlpTypography>
            <SlpTypography variant="heading5">{{
              category.cta.text
            }}</SlpTypography>
            <SlpButton
              :href="category.cta.button.href"
              variant="tertiary"
              :data-ga-name="category.cta.button.dataGaName"
              :data-ga-location="category.title"
              >{{ category.cta.button.text
              }}<SlpIcon name="chevron-right" variant="product"
            /></SlpButton>
          </div>
          <div v-if="footerLinks.length > 1" class="footnote">
            <SlpTypography>
              {{ footer[0] }}
              <a
                href="#why-gitlab-categories"
                class="footer-link"
                :data-ga-name="footerLinks[0].title"
                data-ga-location="body"
                @click="setSelectedCategory(footerLinks[0].index)"
                >{{ footerLinks[0].title }}</a
              >
              {{ footer[1] }}
              <a
                href="#why-gitlab-categories"
                class="footer-link"
                :data-ga-name="footerLinks[1].title"
                data-ga-location="body"
                @click="setSelectedCategory(footerLinks[1].index)"
                >{{ footerLinks[1].title }}</a
              >
              {{ footer[2] }}
            </SlpTypography>
          </div>
        </div>
      </transition>
    </div>
  </SlpContainer>
</template>

<style lang="scss" scoped>
#why-gitlab-categories {
  display: flex;
  flex-direction: column;
  gap: 70px;
  margin: 64px 0;
  .selector-block {
    display: flex;
    flex-direction: row;
    justify-content: center;
    padding: 32px 0px;
    background: #f6f3fe;
    border-radius: 100px;
    max-height: 104px;
    .selector {
      height: 45px;
      overflow: hidden;
      transition: all 0.3s;
      cursor: pointer;
      user-select: none;

      &.open {
        height: 200px;
        overflow: visible;
      }
      .option-container {
        transition: all 0.3s;
        background: $color-surface-800;
        border-radius: 4px;
        padding: 25px;
        display: inline-flex;
        flex-direction: column;
        gap: 25px;
        align-items: flex-start;

        // Base position to offset padding
        transform: translateY(-25px);
        &.step-1 {
          transform: translateY(-90px);
        }
        &.step-2 {
          transform: translateY(-155px);
        }
        .option {
          &.selected {
            border-bottom: 2px solid #7759c2;
            .label .chevron {
              opacity: 1;
            }
          }
          .label {
            display: flex;
            flex-direction: row;
            align-items: center;
            color: #7759c2;
            .chevron {
              align-self: center;
              transition: all 0.3s;
              opacity: 0;
              margin-left: 8px;

              &.open {
                transform: rotate(180deg);
              }
            }
          }
        }
      }
    }
  }
  .category {
    display: flex;
    flex-direction: column;
    gap: 64px;
    .information {
      display: flex;
      flex-direction: column;
      gap: 65px;
      @media (min-width: $breakpoint-lg) {
        justify-content: space-between;
        flex-direction: row;
      }
      .bullets {
        display: flex;
        flex-direction: column;
        flex-basis: 50%;
        gap: 40px;
        .bullet-accordion {
          display: flex;
          justify-content: space-between;
          gap: 32px;
          &.has-content {
            cursor: pointer;
          }
        }
        .bullet {
          display: flex;
          gap: 16px;
          .counter {
            color: $color-accent-500;
          }
          .bullet-text {
            display: flex;
            gap: 16px;
            flex-direction: column;
          }
        }
      }

      .customer-case {
        flex-basis: 50%;
        .case-wrapper {
          display: flex;
          padding: 40px;
          gap: 24px;
          flex-direction: column;
          background: #f6f3fe;
          border-radius: 0px 8px 100px 0px;
          align-items: flex-start;
          .logo {
            max-height: 48px;
          }
        }
      }
    }
    .cta {
      display: flex;
      flex-direction: column;
      gap: 16px;

      background: #ffffff;
      border: 1px solid #eee7fd;
      border-radius: 16px;
      padding: 40px 64px;

      @media (max-width: $breakpoint-lg) {
        padding: 16px;
      }
    }
    .footnote {
      text-align: center;
      .footer-link {
        font-weight: 600;
        cursor: pointer;
        &:hover {
          text-decoration: underline;
        }
      }
    }
  }
}

.hide-in-mobile {
  @media (max-width: $breakpoint-lg) {
    display: none;
  }
}

.accordion {
  padding-top: 16px;
  .content:deep(p) {
    margin-bottom: 16px;
  }
  // .content:deep(ul) {
  //   list-style: disc;
  // }
}

.expand {
  .details {
    display: flex;
    gap: 8px;
    align-items: center;
    justify-content: space-between;
  }

  border-top: 1px solid #d1d0d3;
  border-bottom: 1px solid #d1d0d3;
  padding: 16px 0;
}
</style>
